
 /* The Agat!
    (c)2000 by SerGo
     -9  PC.
     - 19  2000
      - 20  2000
      - 2  2000
 */

 //   - !

 //    
 #include <StdIO.h>
 #include <ConIO.h>
 #include <StdLib.h>

 //   h-
 //    
 #include "GraphLib.h"
 #include "Global.h"
 #include "CLK.h"
 #include "CPU.h"
 #include "MEM.h"
 #include "VS.h"
 #include "KB.h"
 #include "Sound.h"

 //    /  
 #include "NewTI2.h"

 //   cpp-
 #include "GraphLib.cpp"
 #include "CLK.cpp"
 #include "CPU.cpp"
 #include "MEM.cpp"
 #include "VS.cpp"
 #include "KB.cpp"
 #include "Sound.cpp"

 void ShowStartForm();
 void Demo();

 void main()
 {
    // 
    ShowStartForm();

    //  :  , , ,
    // , 
    TCLK CLK;
    TCPU CPU;
    TMEM MEM;
    TVS VS;
    TKB KB;

    //   
    CLK.Init(&CPU, &MEM, &VS);
    CPU.Init(&MEM, &VS, &KB);
    MEM.Init(&VS, &KB);
    VS.Init(&MEM);
    KB.Init(&MEM);

    //     0xF800
    /*FILE *ROMFile;
    ROMFile=fopen("ROM.bin","rb");
    if(!ROMFile)
       Bye("Main","Cannot open ROM.bin");
    fseek(ROMFile, 0, SEEK_END);
    TWord ROMFileLength=ftell(ROMFile);
    fseek(ROMFile, 0, SEEK_SET);
    for(TWord i=0; i<ROMFileLength; i++)
       MEM.Cell[0xF800+i]=fgetc(ROMFile);*/
    //   
    //CLK.On();
    //VS.SetMode(0xC700);
    //while(!kbhit())
    //   MEM.Write(0x0000+random(0x4000), 0xFF);//random(0xFF));
 }

 void ShowStartForm()
 {
    InitNewTI();

    //  
    DeskTop MainDeskTop(1, 1, 80, 25);
    MainDeskTop.Show();

    //  
    Win MainWin(3, 2, 77, 22, "");
    MainWin.Show();

    //   
    Win TitleWin(6, 3, 45 , 7, "");
    TitleWin.Show();
    TitleWin.TextColor=LightMagenta;
    TitleWin.Out(9, 1, "         Agat!");
    TitleWin.TextColor=White;
    TitleWin.Out(9, 2, "  SoftEmulator for PC");
    TitleWin.Out(9, 3, "    Free beta v0.8");

    //   
    Win InfoWin(6, 9, 45, 20, "");
    InfoWin.Show();
    InfoWin.TextColor=White;
    InfoWin.Out(2, 2, "   - command set of MS6502");
    InfoWin.Out(2, 3, "   - memory organisation");
    InfoWin.Out(2, 4, "   - text and graphic modes");
    InfoWin.Out(2, 5, "   - keyboard");
    InfoWin.Out(2, 6, "   - disk");
    InfoWin.Out(2, 7, "   - printer");
    InfoWin.Out(2, 8, "   - sound");
    InfoWin.Out(2, 9, "   - Apple II");
    InfoWin.TextColor=LightMagenta;
    InfoWin.Out(32, 2, "96%");
    InfoWin.Out(32, 3, "60%");
    InfoWin.Out(32, 4, "96%");
    InfoWin.Out(32, 5, "40%");
    InfoWin.Out(32, 6, "00%");
    InfoWin.Out(32, 7, "00%");
    InfoWin.Out(32, 8, "00%");
    InfoWin.Out(32, 9, "00%");

    //      
    StatusLine StatusBar(25);
    StatusBar.Show();
    xy(65, 25);
    SetTC(Black);
    print("(c)2000");
    SetTC(Red);
    print(" SerGo");

    // 
    const int ButtonsNumber=4;
    Button Buttons[ButtonsNumber];

    StringCopy(Buttons[0].ButtonTitle, "Run!");
    Buttons[0].x1=50;
    Buttons[0].y1=5;
    Buttons[0].x2=74;
    Buttons[0].y2=6;

    StringCopy(Buttons[1].ButtonTitle, "About");
    Buttons[1].x1=Buttons[0].x1;
    Buttons[1].y1=Buttons[0].y1+5;
    Buttons[1].x2=Buttons[0].x2;
    Buttons[1].y2=Buttons[0].y2+5;

    StringCopy(Buttons[2].ButtonTitle, "Demo");
    Buttons[2].x1=Buttons[1].x1;
    Buttons[2].y1=Buttons[1].y1+4;
    Buttons[2].x2=Buttons[1].x2;
    Buttons[2].y2=Buttons[1].y2+4;

    StringCopy(Buttons[3].ButtonTitle, "Exit");
    Buttons[3].x1=Buttons[2].x1;
    Buttons[3].y1=Buttons[2].y1+4;
    Buttons[3].x2=Buttons[2].x2;
    Buttons[3].y2=Buttons[2].y2+4;

    for(int i=0; i<ButtonsNumber; i++)
       Buttons[i].Show();

 #define UP 72
 #define DOWN 80
 #define ENTER 13
 #define ESC 27
 #define TAB 9

    int key;
    int CurrentButton=0;
    Frame TheFrame(0, 0, 0, 0);

    //  
    while(1)
    {
       TheFrame.Color=LightMagenta;
       TheFrame.x1=Buttons[CurrentButton].x1-1;
       TheFrame.y1=Buttons[CurrentButton].y1-1;
       TheFrame.x2=Buttons[CurrentButton].x2;
       TheFrame.y2=Buttons[CurrentButton].y2;
       TheFrame.Show();

       key=0;
       while(!key)
          key=getch();
       switch(key)
       {
          case ESC:
             exit(0);
             break;
          case ENTER:
             switch(CurrentButton)
             {
                case 0:
                {
                   Win RunWin(20, 10, 60, 15, " Warning! ");
                   RunWin.TitleColor=Orange;
                   RunWin.Show();
                   SetTC(White);
                   Center(12, "SoftEmulator is under construction,");
                   Center(13, "and not work. Use button 'Demo'.");
                   key=0;
                   while(!key)
                     key=getch();
                   RunWin.Hide();
                   break;
                }
                case 1:
                {
                   Win AboutWin(20, 8, 60, 15, " About ");
                   AboutWin.TitleColor=Orange;
                   AboutWin.Show();
                   SetBC(Blue);
                   SetTC(LightMagenta);
                   Center(10, "Agat! v0.8");
                   SetTC(White);
                   Center(12, "(c)2000 Sergey Goculjak");
                   Center(13, "PolyTech VVT-407");
                   key=0;
                   while(!key)
                     key=getch();
                   AboutWin.Hide();
                   break;
                }
                case 2:
                   Demo();
                   exit(0);
                   break;
                case 3:
                   exit(0);
                   break;
             }
             break;
          case UP:
          {
             TheFrame.Color=White;
             for(int i=0; i<ButtonsNumber; i++)
             {
                TheFrame.x1=Buttons[i].x1-1;
                TheFrame.y1=Buttons[i].y1-1;
                TheFrame.x2=Buttons[i].x2;
                TheFrame.y2=Buttons[i].y2;
                TheFrame.Show();
             }
             if(CurrentButton>0)
                CurrentButton--;
             else
                CurrentButton=ButtonsNumber-1;
             break;
          }
          case TAB:
          case DOWN:
          {
             TheFrame.Color=White;
             for(int i=0; i<ButtonsNumber; i++)
             {
                TheFrame.x1=Buttons[i].x1-1;
                TheFrame.y1=Buttons[i].y1-1;
                TheFrame.x2=Buttons[i].x2;
                TheFrame.y2=Buttons[i].y2;
                TheFrame.Show();
             }
             if(CurrentButton<ButtonsNumber-1)
                CurrentButton++;
             else
                CurrentButton=0;
             break;
          }
       }
    }
 }

 void Demo()
 {
    //  :  , , ,
    // , 
    TCLK CLK;
    TCPU CPU;
    TMEM MEM;
    TVS VS;
    TKB KB;

    //   
    CLK.Init(&CPU, &MEM, &VS);
    CPU.Init(&MEM, &VS, &KB);
    MEM.Init(&VS, &KB);
    VS.Init(&MEM);
    KB.Init(&MEM);

    DeskTop MainDeskTop(1, 1, 80, 25);
    MainDeskTop.Show();
    StatusLine StatusBar(25);

    //     32*32
    Set0x03Mode();
    MainDeskTop.Show();
    StatusBar.Show();
    xy(68, 25);
    SetTC(Red);
    print("SerGo");
    SetTC(Black);
    print(" Demo");
    Win InfoWin(13, 9, 67, 14 ," Info ");
    InfoWin.TitleColor=Orange;
    InfoWin.TextColor=White;
    InfoWin.Show();
    SetBC(Blue);
    SetTC(White);
    Center(11, "Demonstrtation of color text mode 32*32");
    Center(12, "Random fill of screen by color symbols");
    while(!kbhit());
    getch();
    InfoWin.Hide();
    Set0x12Mode();

    MEM.Write(0xC702, 0x00);
    while(!kbhit())
       MEM.Write(random(0x0800), random(0xFF));
    getch();

    //     64*32
    for(TWord i=0; i<0x4000; i++)
       MEM.Cell[i]=0;
    Set0x03Mode();
    MainDeskTop.Show();
    StatusBar.Show();
    xy(68, 25);
    SetTC(Red);
    print("SerGo");
    SetTC(Black);
    print(" Demo");
    InfoWin.Show();
    SetBC(Blue);
    SetTC(White);
    Center(11, "Demonstrtation of monochrome text mode 64*32");
    Center(12, "Random fill of screen by symbols");
    while(!kbhit());
    getch();
    InfoWin.Hide();
    Set0x12Mode();

    MEM.Write(0xC782, 0x00);
    while(!kbhit())
       MEM.Write(random(0x0800), random(0xFF));
    getch();

    //     256*256
    Set0x03Mode();
    MainDeskTop.Show();
    StatusBar.Show();
    xy(68, 25);
    SetTC(Red);
    print("SerGo");
    SetTC(Black);
    print(" Demo");
    InfoWin.Show();
    Center(11, "Demonstrtation of monochrom graphic mode 256*256");
    Center(12, "Random fill of screen by pixels");
    while(!kbhit());
    getch();
    InfoWin.Hide();
    Set0x12Mode();

    for(TWord i=0x0000; i<0x2000; i++)
       MEM.Cell[i]=0;
    MEM.Write(0xC703, 0x00);
    while(!kbhit())
       MEM.Write(random(0x2000), random(0xFF));
    getch();

    //     256*256
    Set0x03Mode();
    MainDeskTop.Show();
    StatusBar.Show();
    xy(68, 25);
    SetTC(Red);
    print("SerGo");
    SetTC(Black);
    print(" Demo");
    InfoWin.Show();
    Center(11, "Demonstrtation of color graphic mode 256*256");
    Center(12, "Random fill of screen by color pixels");
    while(!kbhit());
    getch();
    InfoWin.Hide();
    Set0x12Mode();

    MEM.Write(0xC700, 0x00);
    while(!kbhit())
       MEM.Write(random(0x4000), random(0xFF));
    getch();

    //     512*256
    Set0x03Mode();
    MainDeskTop.Show();
    StatusBar.Show();
    xy(68, 25);
    SetTC(Red);
    print("SerGo");
    SetTC(Black);
    print(" Demo");
    InfoWin.Show();
    Center(11, "Demonstrtation of monochrom graphic mode 512*256");
    Center(12, "Random fill of screen by pixels");
    while(!kbhit());
    getch();
    InfoWin.Hide();
    Set0x12Mode();

    MEM.Write(0xC783, 0x00);
    while(!kbhit())
       MEM.Write(random(0x4000), random(0xFF));
    getch();

    //   
    Set0x03Mode();
    MainDeskTop.Show();
    StatusBar.Show();
    xy(68, 25);
    SetTC(Red);
    print("SerGo");
    SetTC(Black);
    print(" Demo");
    InfoWin.y1=2;
    InfoWin.y2=6;
    InfoWin.Show();
    SetBC(Blue);
    SetTC(White);
    Center(3, "Demonstrtation of keyboard");
    Center(4, "Prees any alphabet or digital keys,");
    Center(5, "and at the end - ESC for quit");
    Win InputWin(10, 9, 70, 22, " Input ");
    InputWin.TitleColor=Orange;
    InputWin.Show();

    SetBC(Blue);
    SetTC(White);
    int key=0;
    int x=11;
    int y=10;
    while(key!=27)
    {
       MEM.Write(0xC010,0);
       key=MEM.Read(0xC000);
       x++;
       if(x>68)
       {
          x=12;
          y++;
          if(y>21)
             y=10;
       }
       qput(x, y, key);
    }
    InfoWin.Hide();
    InputWin.Hide();

    //   
    Set0x03Mode();
    MainDeskTop.Show();
    StatusBar.Show();
    xy(68, 25);
    SetTC(Red);
    print("SerGo");
    SetTC(Black);
    print(" Demo");
    InfoWin.y1=9;
    InfoWin.y2=16;
    InfoWin.Show();
    SetBC(Blue);
    SetTC(White);
    Center(11, "Demonstrtation of virtual processor UM6502");
    Center(12, "It will do simple program - 'Hello, world!'");
    Center(13, "If you intresting on the listing -");
    Center(14, "see 'Hello.asm' in subdirectory '..\\DOC'");
    while(!kbhit());
    getch();
    InfoWin.Hide();
    Set0x12Mode();
    for(TWord i=0x1000; i<0x1800; i++)
       MEM.Cell[i]=0;
    MEM.Write(0xC70A, 0x00);

    MEM.Cell[0x0000]=0x4C;
    MEM.Cell[0x0001]=0x00;
    MEM.Cell[0x0002]=0x01;
    MEM.Cell[0x0003]='H';
    MEM.Cell[0x0004]=0x27;
    MEM.Cell[0x0005]='e';
    MEM.Cell[0x0006]=0x24;
    MEM.Cell[0x0007]='l';
    MEM.Cell[0x0008]=0x21;
    MEM.Cell[0x0009]='l';
    MEM.Cell[0x000A]=0x27;
    MEM.Cell[0x000B]='o';
    MEM.Cell[0x000C]=0x24;
    MEM.Cell[0x000D]=',';
    MEM.Cell[0x000E]=0x21;
    MEM.Cell[0x000F]=' ';
    MEM.Cell[0x0010]=0x27;
    MEM.Cell[0x0011]='w';
    MEM.Cell[0x0012]=0x24;
    MEM.Cell[0x0013]='o';
    MEM.Cell[0x0014]=0x21;
    MEM.Cell[0x0015]='r';
    MEM.Cell[0x0016]=0x27;
    MEM.Cell[0x0017]='l';
    MEM.Cell[0x0018]=0x24;
    MEM.Cell[0x0019]='d';
    MEM.Cell[0x001A]=0x21;
    MEM.Cell[0x001B]='!';
    MEM.Cell[0x001C]=0x27;
    MEM.Cell[0x001D]=0x00;
    MEM.Cell[0x0100]=0xA2;
    MEM.Cell[0x0101]=0x03;
    MEM.Cell[0x0102]=0xB5;
    MEM.Cell[0x0103]=0x00;
    MEM.Cell[0x0104]=0xC9;
    MEM.Cell[0x0105]=0x00;
    MEM.Cell[0x0106]=0xF0;
    MEM.Cell[0x0107]=0x07;
    MEM.Cell[0x0108]=0x9D;
    MEM.Cell[0x0109]=0x11;
    MEM.Cell[0x010A]=0x10;
    MEM.Cell[0x010B]=0xE8;
    MEM.Cell[0x010C]=0x4C;
    MEM.Cell[0x010D]=0x02;
    MEM.Cell[0x010E]=0x01;
    MEM.Cell[0x010F]=0x00;

    CPU.PC=0x0000;
    while(1)
    {
       CPU.Tick();
       if(MEM.Cell[CPU.PC]==0x00)
          break;
    }
    getch();

    //  
    Set0x03Mode();
    MainDeskTop.Show();
    StatusBar.Show();
    xy(68, 25);
    SetTC(Red);
    print("SerGo");
    SetTC(Black);
    print(" Demo");
    InfoWin.y2=15;
    InfoWin.Show();
    SetBC(Blue);
    SetTC(White);
    Center(11, "Demonstrtation complete");
    Center(12, "Next version will be much better");
    Center(13, "Bye-bye!");
    while(!kbhit());
    getch();
    InfoWin.Hide();
 }
