
 #ifndef _CPU_CPP
 #define _CPU_CPP

 TCPU::TCPU()
 {
 }

 TCPU::~TCPU()
 {
 }

 void TCPU::Init(TMEM *MEMIn, TVS *VSIn, TKB *KBIn)
 {
    MEM=MEMIn;
    VS=VSIn;
    KB=KBIn;

    /*    */
    //    -   
    PC=0xF800;
    //      
    S=0xFF;
    //  
    X=0;
    Y=0;
    A=0;
    P.All=0;
    Idle=0;
 }

 void TCPU::Tick()
 {
    //      ,   
    //  ,     
    if(Idle!=0 && Idle!=1)
    {
       Idle--;
       return;
    }

    //   
    Command=MEM->Read(PC);
    /*
    Set0x03Mode();
    printf("\n\n *** Trace mode ***");
    printf("\n Command: <%X>", Command);
    printf(" <%X> <%X>",MEM->Cell[PC+1],MEM->Cell[PC+2]);
    printf("\n      PC: %X", PC);
    printf("\n       A: %X '%c'", A, A);
    printf("\n       X: %X", X);
    printf("\n       z: %X", P.the.Z);
    printf("\n       P: %X", P.All);
    getch();
    */
    //  
    switch(Command)
    {
       // BRK 
       case 0x00:
          PushWord(PC+2);
          P.the.B=1;
          PushByte(P.All);
          P.the.I=1;
          PC=MEM->Read(0xFFFF);
          PC<<=8;
          PC=PC+MEM->Read(0xFFFE);
          Idle=7;
          break;

       // ORA (,X)
       case 0x01:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          TByte TempByte=Operand.the.Byte;
          Operand.the.LoByte=MEM->Read(TempByte);
          Operand.the.HiByte=MEM->Read(char(TempByte+1));
          //Operand.Word=MEM->Read(Operand.Word);
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=6;
          break;
       }

       // ORA 
       case 0x05:
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=3;
          break;

       // ASL 
       case 0x06:
          Operand.the.Byte=MEM->Read(PC+1);
          P.the.C=Operand.the.Byte>>7;
          Operand.the.Byte<<=1;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=5;
          break;

       // PHP 
       case 0x08:
          PushByte(P.All);
          PC++;
          Idle=2;
          break;

       // ORA 
       case 0x09:
          Operand.the.Byte=MEM->Read(PC+1);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=2;
          break;

       // ASL 
       case 0x0A:
          P.the.C=A>>7;
          A<<=1;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC++;
          Idle=2;
          break;

       // ORA 
       case 0x0D:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=3;
          Idle=4;
          break;

       // ASL 
       case 0x0E:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          P.the.C=Operand.the.Byte>>7;
          Operand.the.Byte<<=1;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=6;
          break;

       // BPL 
       case 0x10:
          Operand.the.Byte=MEM->Read(PC+1);
          if(!P.the.N)
             PC=int(PC+2)+Operand.the.Byte;
          else
             PC+=2;
          Idle=2;
          break;

       // ORA (),Y
       case 0x11:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          TByte TempByte=Operand.the.Byte;
          Operand.the.LoByte=MEM->Read(TempByte);
          Operand.the.HiByte=MEM->Read(char(TempByte+1));
          Operand.Word+=Y;
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=5;
          break;
       }

       // ORA ,X
       case 0x15:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=4;
          break;
       }

       // ASL ,X
       case 0x16:
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          P.the.C=Operand.the.Byte>>7;
          Operand.the.Byte<<=1;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=6;
          break;

       // CLC 
       case 0x18:
          P.the.C=0;
          PC++;
          Idle=2;
          break;

       // ORA ,Y
       case 0x19:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=Y;
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=3;
          Idle=4;
          break;

       // ORA ,X
       case 0x1D:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=X;
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=3;
          Idle=4;
          break;

       // ASL ,X
       case 0x1E:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=X;
          Operand.the.Byte=MEM->Read(Operand.Word);
          P.the.C=Operand.the.Byte>>7;
          Operand.the.Byte<<=1;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=7;
          break;

       // JSR 
       case 0x20:
          PushWord(PC+2);
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          PC=Operand.Word;
          Idle=6;
          break;

       // AND (,X)
       case 0x21:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          TByte TempByte=Operand.the.Byte;
          Operand.the.LoByte=MEM->Read(TempByte);
          Operand.the.HiByte=MEM->Read(char(TempByte+1));
          //Operand.Word=MEM->Read(Operand.Word);
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A&Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=6;
          break;
       }

       // BIT 
       case 0x24:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          P.the.N=Operand.the.Byte>>7;
          P.the.V=(Operand.the.Byte<<1)>>7;
          A|=Operand.the.Byte;
          PC+=2;
          Idle=3;
          break;
       }

       // AND 
       case 0x25:
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          A=A&Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=3;
          break;

       // ROL 
       case 0x26:
       {
          TByte TempC=P.the.C;
          Operand.the.Byte=MEM->Read(PC+1);
          P.the.C=Operand.the.Byte<<1;
          Operand.the.Byte<<=1;
          Operand.the.Byte|=TempC;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=5;
          break;
       }

       // PLP 
       case 0x28:
          P.All=PopByte();
          P.the.B=0;
          PC++;
          Idle=4;
          break;

       // AND 
       case 0x29:
          Operand.the.Byte=MEM->Read(PC+1);
          A=A&Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=2;
          break;

       // ROL 
       case 0x2A:
       {
          TByte TempC=P.the.C;
          P.the.C=A<<1;
          A<<=1;
          A|=TempC;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC++;
          Idle=2;
          break;
       }

       // BIT 
       case 0x2C:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          P.the.N=Operand.the.Byte>>7;
          P.the.V=(Operand.the.Byte<<1)>>7;
          A|=Operand.the.Byte;
          PC+=2;
          Idle=3;
          break;

       // AND 
       case 0x2D:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A&Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=3;
          Idle=4;
          break;

       // ROL 
       case 0x2E:
       {
          TByte TempC=P.the.C;
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          P.the.C=Operand.the.Byte<<1;
          Operand.the.Byte<<=1;
          Operand.the.Byte|=TempC;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=6;
          break;
       }

       // BMI 
       case 0x30:
          Operand.the.Byte=MEM->Read(PC+1);
          if(P.the.N)
             PC=int(PC+2)+Operand.the.Byte;
          else
             PC+=2;
          Idle=2;
          break;

       // AND (),Y
       case 0x31:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          TByte TempByte=Operand.the.Byte;
          Operand.the.LoByte=MEM->Read(TempByte);
          Operand.the.HiByte=MEM->Read(char(TempByte+1));
          Operand.Word+=Y;
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A&Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=5;
          break;
       }

       // AND ,X
       case 0x35:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          A=A&Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=4;
          break;
       }

       // ROL ,X
       case 0x36:
       {
          TByte TempC=P.the.C;
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          P.the.C=Operand.the.Byte<<1;
          Operand.the.Byte<<=1;
          Operand.the.Byte|=TempC;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=6;
          break;
       }

       // SEC 
       case 0x38:
          P.the.C=1;
          PC++;
          Idle=2;
          break;

       // AND ,Y
       case 0x39:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=Y;
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A&Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=3;
          Idle=4;
          break;

       // AND ,X
       case 0x3D:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=X;
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A&Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=3;
          Idle=4;
          break;

       // ROL ,X
       case 0x3E:
       {
          TByte TempC=P.the.C;
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=X;
          Operand.the.Byte=MEM->Read(Operand.Word);
          P.the.C=Operand.the.Byte<<1;
          Operand.the.Byte<<=1;
          Operand.the.Byte|=TempC;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=7;
          break;
       }

       // RTI 
       case 0x40:
          P.All=PopByte();
          PC=PopWord();
          Idle=6;
          break;

       // EOR (,X)
       case 0x41:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          TByte TempByte=Operand.the.Byte;
          Operand.the.LoByte=MEM->Read(TempByte);
          Operand.the.HiByte=MEM->Read(char(TempByte+1));
          Operand.Word=MEM->Read(Operand.Word);
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=6;
          break;
       }

       // EOR 
       case 0x45:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=3;
          break;
       }

       // LSR 
       case 0x46:
          Operand.the.Byte=MEM->Read(PC+1);
          P.the.C=Operand.the.Byte>>1;
          Operand.the.Byte>>=1;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=5;
          break;

       // PHA 
       case 0x48:
          PushByte(A);
          PC++;
          Idle=3;
          break;

       // EOR 
       case 0x49:
          Operand.the.Byte=MEM->Read(PC+1);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=2;
          break;

       // LSR 
       case 0x4A:
          P.the.C=A>>1;
          A>>=1;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC++;
          Idle=2;
          break;

       // JMP 
       case 0x4C:
       {
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          PC=Operand.Word;
          Idle=3;
          break;
       }

       // EOR 
       case 0x4D:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=3;
          Idle=4;
          break;

       // LSR 
       case 0x4E:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          P.the.C=Operand.the.Byte>>1;
          Operand.the.Byte>>=1;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=6;
          break;

       // BVC 
       case 0x50:
          Operand.the.Byte=MEM->Read(PC+1);
          if(!P.the.V)
             PC=int(PC+2)+Operand.the.Byte;
          else
             PC+=2;
          Idle=2;
          break;

       // EOR (),Y
       case 0x51:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          TByte TempByte=Operand.the.Byte;
          Operand.the.LoByte=MEM->Read(TempByte);
          Operand.the.HiByte=MEM->Read(char(TempByte+1));
          Operand.Word+=Y;
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=5;
          break;
       }

       // AND ,X
       case 0x55:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=4;
          break;
       }

       // LSR ,X
       case 0x56:
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          P.the.C=Operand.the.Byte>>1;
          Operand.the.Byte>>=1;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=6;
          break;

       // CLI 
       case 0x58:
          P.the.I=0;
          PC++;
          Idle=2;
          break;

       // EOR ,Y
       case 0x59:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=Y;
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=3;
          Idle=4;
          break;

       // EOR ,X
       case 0x5D:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=X;
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=A|Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=3;
          Idle=4;
          break;

       // LSR ,X
       case 0x5E:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=X;
          Operand.the.Byte=MEM->Read(Operand.Word);
          P.the.C=Operand.the.Byte>>1;
          Operand.the.Byte>>=1;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=7;
          break;

       // RTS 
       case 0x60:
          PC=PopWord();
          PC++;
          Idle=6;
          break;

       // ADC (,X)
       case 0x61:
          if(P.the.D)
             Bye("CPU","ADC in decimal mode");
          else
          {
             Operand.the.Byte=MEM->Read(PC+1);
             Operand.the.Byte+=X;
             TByte TempByte=Operand.the.Byte;
             if(TempByte==0xFF)
             {
                Operand.the.LoByte=MEM->Read(0xFF);
                Operand.the.HiByte=MEM->Read(0x00);
             }
             else
             {
                Operand.the.LoByte=MEM->Read(TempByte);
                Operand.the.HiByte=MEM->Read(TempByte+1);
             }
             Operand.Word=MEM->Read(Operand.Word);
             Operand.the.Byte=MEM->Read(Operand.Word);
             TWord Result=A+Operand.the.Byte+P.the.C;
             if(Result>>8)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) == (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=6;
          break;

       // ADC 
       case 0x65:
          if(P.the.D)
             Bye("CPU","ADC in decimal mode");
          else
          {
             Operand.the.Byte=MEM->Read(PC+1);
             Operand.the.Byte=MEM->Read(Operand.the.Byte);
             TWord Result=A+Operand.the.Byte+P.the.C;
             if(Result>>8)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) == (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=3;
          break;

       // ROR 
       case 0x66:
       {
          TByte TempC=P.the.C;
          TempC<<=7;
          Operand.the.Byte=MEM->Read(PC+1);
          P.the.C=Operand.the.Byte>>1;
          Operand.the.Byte>>=1;
          Operand.the.Byte|=TempC;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=5;
          break;
       }

       // PLA 
       case 0x68:
          A=PopByte();
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC++;
          Idle=4;
          break;

       // ADC 
       case 0x69:
          if(P.the.D)
             Bye("CPU","ADC in decimal mode");
          else
          {
             Operand.the.Byte=MEM->Read(PC+1);
             TWord Result=A+Operand.the.Byte+P.the.C;
             if(Result>>8)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) == (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=2;
          break;

       // ROR 
       case 0x6A:
       {
          TByte TempC=P.the.C;
          TempC<<=7;
          P.the.C=A>>1;
          A>>=1;
          A|=TempC;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC++;
          Idle=2;
          break;
       }

       // JMP ()
       case 0x6C:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          if(Operand.Word==0xFFFF)
          {
             Operand.the.LoByte=MEM->Read(0xFFFF);
             Operand.the.HiByte=MEM->Read(0xFF00);
          }
          else
             Operand.Word=MEM->Read(Operand.Word);
          PC=Operand.Word;
          Idle=5;
          break;

       // ADC 
       case 0x6D:
          if(P.the.D)
             Bye("CPU","ADC in decimal mode");
          else
          {
             Operand.the.LoByte=MEM->Read(PC+1);
             Operand.the.HiByte=MEM->Read(PC+2);
             Operand.the.Byte=MEM->Read(Operand.Word);
             TWord Result=A+Operand.the.Byte+P.the.C;
             if(Result>>8)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) == (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=3;
          Idle=4;
          break;

       // ROR 
       case 0x6E:
       {
          TByte TempC=P.the.C;
          TempC<<=7;
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          P.the.C=Operand.the.Byte>>1;
          Operand.the.Byte>>=1;
          Operand.the.Byte|=TempC;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=6;
          break;
       }

       // BVS 
       case 0x70:
          Operand.the.Byte=MEM->Read(PC+1);
          if(P.the.V)
             PC=int(PC+2)+Operand.the.Byte;
          else
             PC+=2;
          Idle=2;
          break;

       // ADC (),Y
       case 0x71:
          if(P.the.D)
             Bye("CPU","ADC in decimal mode");
          else
          {
             TWord TempByte=MEM->Read(PC+1);
             if(Operand.the.Byte==0xFF)
             {
                Operand.the.LoByte=MEM->Read(0x00);
                Operand.the.HiByte=MEM->Read(0xFF);
             }
             else
             {
                Operand.the.LoByte=MEM->Read(TempByte);
                Operand.the.HiByte=MEM->Read(TempByte+1);
             }
             Operand.Word+=Y;
             Operand.the.Byte=MEM->Read(Operand.Word);
             TWord Result=A+Operand.the.Byte+P.the.C;
             if(Result>>8)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) == (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=5;
          break;

       // ADC ,X
       case 0x75:
          if(P.the.D)
             Bye("CPU","ADC in decimal mode");
          else
          {
             Operand.the.Byte=MEM->Read(PC+1);
             Operand.the.Byte=Operand.the.Byte+X;
             Operand.the.Byte=MEM->Read(Operand.the.Byte);
             TWord Result=A+Operand.the.Byte+P.the.C;
             if(Result>>8)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) == (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=4;
          break;

       // ROR ,X
       case 0x76:
       {
          TByte TempC=P.the.C;
          TempC<<=7;
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          P.the.C=Operand.the.Byte>>1;
          Operand.the.Byte>>=1;
          Operand.the.Byte|=TempC;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=6;
          break;
       }

       // SEI 
       case 0x78:
          P.the.I=1;
          PC++;
          Idle=2;
          break;

       // ADC ,Y
       case 0x79:
          if(P.the.D)
             Bye("CPU","ADC in decimal mode");
          else
          {
             Operand.the.LoByte=MEM->Read(PC+1);
             Operand.the.HiByte=MEM->Read(PC+2);
             Operand.Word=Operand.Word+Y;
             Operand.the.Byte=MEM->Read(Operand.Word);
             TWord Result=A+Operand.the.Byte+P.the.C;
             if(Result>>8)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) == (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=4;
          break;

       // ADC ,X
       case 0x7D:
          if(P.the.D)
             Bye("CPU","ADC in decimal mode");
          else
          {
             Operand.the.LoByte=MEM->Read(PC+1);
             Operand.the.HiByte=MEM->Read(PC+2);
             Operand.Word=Operand.Word+X;
             Operand.the.Byte=MEM->Read(Operand.Word);
             TWord Result=A+Operand.the.Byte+P.the.C;
             if(Result>>8)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) == (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=4;
          break;

       // ROR ,X
       case 0x7E:
       {
          TByte TempC=P.the.C;
          TempC<<=7;
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=X;
          Operand.the.Byte=MEM->Read(Operand.Word);
          P.the.C=Operand.the.Byte>>1;
          Operand.the.Byte>>=1;
          Operand.the.Byte|=TempC;
          if(Operand.the.Byte)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Operand.the.Byte>>7;
          PC+=2;
          Idle=7;
          break;
       }

       // STA (,X)
       case 0x81:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          TByte TempByte=Operand.the.Byte;
          Operand.the.LoByte=MEM->Read(TempByte);
          Operand.the.HiByte=MEM->Read(char(TempByte+1));
          MEM->Write(Operand.Word, A);
          PC+=2;
          Idle=6;
          break;
       }

       // STY 
       case 0x84:
          Operand.the.Byte=MEM->Read(PC+1);
          MEM->Write(Operand.the.Byte, Y);
          PC+=2;
          Idle=3;
          break;

       // STA 
       case 0x85:
          Operand.the.Byte=MEM->Read(PC+1);
          MEM->Write(Operand.the.Byte, A);
          PC+=2;
          Idle=3;
          break;

       // STX 
       case 0x86:
          Operand.the.Byte=MEM->Read(PC+1);
          MEM->Write(Operand.the.Byte, X);
          PC+=2;
          Idle=3;
          break;

       // DEY  
       case 0x88:
          Y--;
          if(Y)
             P.the.Z=1;
          else
             P.the.Z=1;
          P.the.N=Y>>7;
          PC++;
          Idle=2;
          break;

       // TXA 
       case 0x8A:
          A=X;
          P.the.N=A>>7;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC++;
          Idle=2;
          break;

       // STY 
       case 0x8C:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          MEM->Write(Operand.Word, Y);
          PC+=3;
          Idle=4;
          break;

       // STA 
       case 0x8D:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          MEM->Write(Operand.Word, A);
          PC+=3;
          Idle=4;
          break;

       // STX 
       case 0x8E:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          MEM->Write(Operand.Word, X);
          PC+=3;
          Idle=4;
          break;

       // BCC 
       case 0x90:
          Operand.the.Byte=MEM->Read(PC+1);
          if(!P.the.C)
             PC=int(PC+2)+Operand.the.Byte;
          else
             PC+=2;
          Idle=2;
          break;

       // STA (),Y
       case 0x91:
       {
          TByte TempByte=MEM->Read(PC+1);
          Operand.the.LoByte=MEM->Read(TempByte);
          Operand.the.HiByte=MEM->Read(char(TempByte+1));
          MEM->Write(Operand.Word, A);
          PC+=2;
          Idle=5;
          break;
       }

       // STY ,X
       case 0x94:
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          MEM->Write(Operand.the.Byte, Y);
          PC+=2;
          Idle=4;
          break;

       // STA ,X
       case 0x95:
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          MEM->Write(Operand.the.Byte, A);
          PC+=2;
          Idle=4;
          break;

       // STX ,Y
       case 0x96:
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=Y;
          MEM->Write(Operand.the.Byte, X);
          PC+=2;
          Idle=4;
          break;

       // TYA 
       case 0x98:
          A=Y;
          P.the.N=A>>7;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC++;
          Idle=2;
          break;

       // STA ,Y
       case 0x99:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=Y;
          MEM->Write(Operand.Word, A);
          PC+=3;
          Idle=5;
          break;

       // TXS 
       case 0x9A:
          S=X;
          PC++;
          Idle=2;
          break;

       // STA ,X
       case 0x9D:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=X;
          MEM->Write(Operand.Word, A);
          PC+=3;
          Idle=5;
          break;

       // LDY 
       case 0xA0:
          Operand.the.Byte=MEM->Read(PC+1);
          Y=Operand.the.Byte;
          if(Y)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Y>>7;
          PC+=2;
          Idle=2;
          break;

       // LDA (,X)
       case 0xA1:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          TByte TempByte=Operand.the.Byte;
          Operand.the.LoByte=MEM->Read(TempByte);
          Operand.the.HiByte=MEM->Read(char(TempByte+1));
          Operand.Word=MEM->Read(Operand.Word);
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=6;
          break;
       }

       // LDX 
       case 0xA2:
          Operand.the.Byte=MEM->Read(PC+1);
          X=Operand.the.Byte;
          if(X)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=X>>7;
          PC+=2;
          Idle=2;
          break;

       // LDY 
       case 0xA4:
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          Y=Operand.the.Byte;
          if(Y)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Y>>7;
          PC+=2;
          Idle=3;
          break;

       // LDA 
       case 0xA5:
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          A=Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=3;
          break;

       // LDX 
       case 0xA6:
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          X=Operand.the.Byte;
          if(X)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=X>>7;
          PC+=2;
          Idle=3;
          break;

       // TAY 
       case 0xA8:
          Y=A;
          P.the.N=A>>7;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC++;
          Idle=2;
          break;

       // LDA 
       case 0xA9:
          Operand.the.Byte=MEM->Read(PC+1);
          A=Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=2;
          break;

       // TAX 
       case 0xAA:
          X=A;
          P.the.N=A>>7;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC++;
          Idle=2;
          break;

       // LDY 
       case 0xAC:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          Y=Operand.the.Byte;
          if(Y)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Y>>7;
          PC+=3;
          Idle=4;
          break;

       // LDA 
       case 0xAD:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=3;
          Idle=4;
          break;

       // LDX 
       case 0xAE:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          X=Operand.the.Byte;
          if(X)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=X>>7;
          PC+=3;
          Idle=4;
          break;

       // BCS 
       case 0xB0:
          Operand.the.Byte=MEM->Read(PC+1);
          if(P.the.C)
             PC=int(PC+2)+Operand.the.Byte;
          else
             PC+=2;
          Idle=2;
          break;

       // LDA (),Y
       case 0xB1:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          TByte TempByte=Operand.the.Byte;
          Operand.the.LoByte=MEM->Read(TempByte);
          Operand.the.HiByte=MEM->Read(char(TempByte+1));
          Operand.Word+=Y;
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=5;
          break;
       }

       // LDY ,X
       case 0xB4:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          Y=Operand.the.Byte;
          if(Y)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Y>>7;
          PC+=2;
          Idle=4;
          break;
       }

       // LDA ,X
       case 0xB5:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          A=Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=2;
          Idle=4;
          break;
       }

       // LDX ,Y
       case 0xB6:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=Y;
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          X=Operand.the.Byte;
          if(X)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=X>>7;
          PC+=2;
          Idle=4;
          break;
       }

       // CLV  
       case 0xB8:
          P.the.V=0;
          PC++;
          Idle=2;
          break;

       // LDA ,Y
       case 0xB9:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=Y;
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=3;
          Idle=4;
          break;

       // TSX 
       case 0xBA:
          X=S;
          P.the.N=X>>7;
          if(X)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC++;
          Idle=2;
          break;

       // LDY ,X
       case 0xBC:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=X;
          Operand.the.Byte=MEM->Read(Operand.Word);
          Y=Operand.the.Byte;
          if(Y)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Y>>7;
          PC+=3;
          Idle=4;
          break;

       // LDA ,X
       case 0xBD:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=X;
          Operand.the.Byte=MEM->Read(Operand.Word);
          A=Operand.the.Byte;
          if(A)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=A>>7;
          PC+=3;
          Idle=4;
          break;

       // LDX ,Y
       case 0xBE:
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=Y;
          Operand.the.Byte=MEM->Read(Operand.Word);
          X=Operand.the.Byte;
          if(X)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=X>>7;
          PC+=3;
          Idle=4;
          break;

       // CPY 
       case 0xC0:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          TByte Result=Y-Operand.the.Byte;
          if(Result==Y)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=2;
          Idle=2;
          break;
       }

       // CMP (,X)
       case 0xC1:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          TByte TempByte=Operand.the.Byte;
          if(TempByte==0xFF)
          {
             Operand.the.LoByte=MEM->Read(0xFF);
             Operand.the.HiByte=MEM->Read(0x00);
          }
          else
          {
             Operand.the.LoByte=MEM->Read(TempByte);
             Operand.the.HiByte=MEM->Read(TempByte+1);
          }
          Operand.Word=MEM->Read(Operand.Word);
          Operand.the.Byte=MEM->Read(Operand.Word);
          TWord Result=A-Operand.the.Byte;
          if(A==Operand.the.Byte)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=2;
          Idle=6;
          break;
       }   

       // CPY 
       case 0xC4:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          TByte Result=Y-Operand.the.Byte;
          if(Y==Operand.the.Byte)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=2;
          Idle=3;
          break;
       }

       // CMP 
       case 0xC5:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          TByte Result=A-Operand.the.Byte;
          if(A==Operand.the.Byte)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=2;
          Idle=3;
          break;
       }

       // DEC 
       case 0xC6:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          TByte TempByte=MEM->Read(Operand.the.Byte);
          TempByte--;
          MEM->Write(Operand.the.Byte, TempByte);
          P.the.N=TempByte>>7;
          if(TempByte)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC+=2;
          Idle=5;
          break;
       }

       // INY 
       case 0xC8:
          Y++;
          if(Y)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Y>>7;
          PC++;
          Idle=2;
          break;

       // CMP 
       case 0xC9:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          TByte Result=A-Operand.the.Byte;
          if(Result==A)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=2;
          Idle=2;
          break;
       }

       // DEX 
       case 0xCA:
          X--;
          if(X)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=X>>7;
          PC++;
          Idle=2;
          break;

       // CPY 
       case 0xCC:
       {
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          TWord Result=Y-Operand.the.Byte;
          if(Y==Operand.the.Byte)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=3;
          Idle=4;
          break;
       }

       // CMP 
       case 0xCD:
       {
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          TWord Result=A-Operand.the.Byte;
          if(A==Operand.the.Byte)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=3;
          Idle=4;
          break;
       }

       // DEC 
       case 0xCE:
       {
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          TByte TempByte=MEM->Read(Operand.Word);
          TempByte--;
          MEM->Write(Operand.Word, TempByte);
          P.the.N=TempByte>>7;
          if(TempByte)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC+=2;
          Idle=6;
          break;
       }

       // BNE 
       case 0xD0:
          Operand.the.Byte=MEM->Read(PC+1);
          if(!P.the.Z)
             PC=int(PC+2)+Operand.the.Byte;
          else
             PC+=2;
          Idle=2;
          break;

       // CMP (),Y
       case 0xD1:
       {
          TWord TempByte=MEM->Read(PC+1);
          if(Operand.the.Byte==0xFF)
          {
             Operand.the.LoByte=MEM->Read(0x00);
             Operand.the.HiByte=MEM->Read(0xFF);
          }
          else
          {
             Operand.the.LoByte=MEM->Read(TempByte);
             Operand.the.HiByte=MEM->Read(TempByte+1);
          }
          Operand.Word+=Y;
          Operand.the.Byte=MEM->Read(Operand.Word);
          TWord Result=A-Operand.the.Byte;
          if(A==Operand.the.Byte)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=2;
          Idle=5;
          break;
       }

       // CMP ,X
       case 0xD5:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte=Operand.the.Byte+X;
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          TWord Result=A-Operand.the.Byte;
          if(A==Operand.the.Byte)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=2;
          Idle=4;
          break;
       }

       // DEC ,X
       case 0xD6:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          TByte TempByte=MEM->Read(Operand.the.Byte);
          TempByte--;
          MEM->Write(Operand.the.Byte, TempByte);
          P.the.N=TempByte>>7;
          if(TempByte)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC+=2;
          Idle=6;
          break;
       }

       // CLD 
       case 0xD8:
          P.the.D=0;
          PC++;
          Idle=2;
          break;

       // CMP ,Y
       case 0xD9:
       {
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word=Operand.Word+Y;
          Operand.the.Byte=MEM->Read(Operand.Word);
          TWord Result=A-Operand.the.Byte;
          if(A==Operand.the.Byte)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=2;
          Idle=4;
          break;
       }

       // CMP ,X
       case 0xDD:
       {
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word=Operand.Word+X;
          Operand.the.Byte=MEM->Read(Operand.Word);
          TWord Result=A-Operand.the.Byte;
          if(A==Operand.the.Byte)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=2;
          Idle=4;
          break;
       }

       // DEC ,X
       case 0xDE:
       {
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=X;
          TByte TempByte=MEM->Read(Operand.Word);
          TempByte--;
          MEM->Write(Operand.Word, TempByte);
          P.the.N=TempByte>>7;
          if(TempByte)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC+=2;
          Idle=7;
          break;
       }

       // CPX 
       case 0xE0:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          TByte Result=X-Operand.the.Byte;
          if(Result==X)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=2;
          Idle=2;
          break;
       }

       // SBC (,X)
       case 0xE1:
          if(P.the.D)
             Bye("CPU","SBC in decimal mode");
          else
          {
             Operand.the.Byte=MEM->Read(PC+1);
             Operand.the.Byte+=X;
             TByte TempByte=Operand.the.Byte;
             if(TempByte==0xFF)
             {
                Operand.the.LoByte=MEM->Read(0xFF);
                Operand.the.HiByte=MEM->Read(0x00);
             }
             else
             {
                Operand.the.LoByte=MEM->Read(TempByte);
                Operand.the.HiByte=MEM->Read(TempByte+1);
             }
             Operand.Word=MEM->Read(Operand.Word);
             Operand.the.Byte=MEM->Read(Operand.Word);
             TWord Result=A-Operand.the.Byte-1+P.the.C;
             if((A-1+P.the.C)>=Operand.the.Byte)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) != (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=6;
          break;

       // CPX 
       case 0xE4:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte=MEM->Read(Operand.the.Byte);
          TByte Result=Y-Operand.the.Byte;
          if(Y==Operand.the.Byte)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=2;
          Idle=3;
          break;
       }

       // SBC 
       case 0xE5:
          if(P.the.D)
             Bye("CPU","SBC in decimal mode");
          else
          {
             Operand.the.Byte=MEM->Read(PC+1);
             Operand.the.Byte=MEM->Read(Operand.the.Byte);
             TWord Result=A-Operand.the.Byte-1+P.the.C;
             if((A-1+P.the.C)>>Operand.the.Byte)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) != (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=3;
          break;

       case 0xE6:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          TByte TempByte=MEM->Read(Operand.the.Byte);
          TempByte++;
          MEM->Write(Operand.the.Byte, TempByte);
          P.the.N=TempByte>>7;
          if(TempByte)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC+=2;
          Idle=5;
          break;
       }

       // INX  
       case 0xE8:
          X++;
          if(X)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=X>>7;
          PC++;
          Idle=2;
          break;

       // NOP 
       case 0xEA:
          PC++;
          Idle=2;
          break;

       // SBC 
       case 0xE9:
          if(P.the.D)
             Bye("CPU","SBC in decimal mode");
          else
          {
             Operand.the.Byte=MEM->Read(PC+1);
             TWord Result=A-Operand.the.Byte-1+P.the.C;
             if((A-1+P.the.C)>=Operand.the.Byte)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) != (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=2;
          break;

       // CPX 
       case 0xEC:
       {
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.the.Byte=MEM->Read(Operand.Word);
          TWord Result=Y-Operand.the.Byte;
          if(Y==Operand.the.Byte)
             P.the.C=1;
          else
             P.the.C=0;
          if(Result)
             P.the.Z=0;
          else
             P.the.Z=1;
          P.the.N=Result>>7;
          PC+=3;
          Idle=4;
          break;
       }

       // SBC 
       case 0xED:
          if(P.the.D)
             Bye("CPU","SBC in decimal mode");
          else
          {
             Operand.the.LoByte=MEM->Read(PC+1);
             Operand.the.HiByte=MEM->Read(PC+2);
             Operand.the.Byte=MEM->Read(Operand.Word);
             TWord Result=A-Operand.the.Byte-1+P.the.C;
             if((A-1+P.the.C)>=Operand.the.Byte)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) != (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=3;
          Idle=4;
          break;

       // INC 
       case 0xEE:
       {
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          TByte TempByte=MEM->Read(Operand.Word);
          TempByte++;
          MEM->Write(Operand.Word, TempByte);
          P.the.N=TempByte>>7;
          if(TempByte)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC+=2;
          Idle=6;
          break;
       }   

       // BEQ 
       case 0xF0:
          Operand.the.Byte=MEM->Read(PC+1);
          if(P.the.Z)
             PC=int(PC+2)+Operand.the.Byte;
          else
             PC+=2;
          Idle=2;
          break;

       // SBC (),Y
       case 0xF1:
          if(P.the.D)
             Bye("CPU","SBC in decimal mode");
          else
          {
             TWord TempByte=MEM->Read(PC+1);
             if(Operand.the.Byte==0xFF)
             {
                Operand.the.LoByte=MEM->Read(0x00);
                Operand.the.HiByte=MEM->Read(0xFF);
             }
             else
             {
                Operand.the.LoByte=MEM->Read(TempByte);
                Operand.the.HiByte=MEM->Read(TempByte+1);
             }
             Operand.Word+=Y;
             Operand.the.Byte=MEM->Read(Operand.Word);
             TWord Result=A-Operand.the.Byte-1+P.the.C;
             if((A-1+P.the.C)>=Operand.the.Byte)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) != (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=5;
          break;

       // SBC ,X
       case 0xF5:
          if(P.the.D)
             Bye("CPU","SBC in decimal mode");
          else
          {
             Operand.the.Byte=MEM->Read(PC+1);
             Operand.the.Byte=Operand.the.Byte+X;
             Operand.the.Byte=MEM->Read(Operand.the.Byte);
             TWord Result=A-Operand.the.Byte-1+P.the.C;
             if((A-1+P.the.C)>=Operand.the.Byte)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) != (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=4;
          break;

       // INC ,X
       case 0xF6:
       {
          Operand.the.Byte=MEM->Read(PC+1);
          Operand.the.Byte+=X;
          TByte TempByte=MEM->Read(Operand.the.Byte);
          TempByte++;
          MEM->Write(Operand.the.Byte, TempByte);
          P.the.N=TempByte>>7;
          if(TempByte)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC+=2;
          Idle=6;
          break;
       }

       // SED 
       case 0xF8:
          P.the.D=1;
          PC++;
          Idle=2;
          break;

       // SBC ,Y
       case 0xF9:
          if(P.the.D)
             Bye("CPU","SBC in decimal mode");
          else
          {
             Operand.the.LoByte=MEM->Read(PC+1);
             Operand.the.HiByte=MEM->Read(PC+2);
             Operand.Word=Operand.Word+Y;
             Operand.the.Byte=MEM->Read(Operand.Word);
             TWord Result=A-Operand.the.Byte-1+P.the.C;
             if((A-1+P.the.C)>=Operand.the.Byte)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) != (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=4;
          break;

       // INC ,X
       case 0xFE:
       {
          Operand.the.LoByte=MEM->Read(PC+1);
          Operand.the.HiByte=MEM->Read(PC+2);
          Operand.Word+=X;
          TByte TempByte=MEM->Read(Operand.Word);
          TempByte++;
          MEM->Write(Operand.Word, TempByte);
          P.the.N=TempByte>>7;
          if(TempByte)
             P.the.Z=0;
          else
             P.the.Z=1;
          PC+=2;
          Idle=7;
          break;
       }

       // SBC ,X
       case 0xFD:
          if(P.the.D)
             Bye("CPU","SBC in decimal mode");
          else
          {
             Operand.the.LoByte=MEM->Read(PC+1);
             Operand.the.HiByte=MEM->Read(PC+2);
             Operand.Word=Operand.Word+X;
             Operand.the.Byte=MEM->Read(Operand.Word);
             TWord Result=A-Operand.the.Byte-1+P.the.C;
             if((A-1+P.the.C)>=Operand.the.Byte)
                P.the.C=1;
             else
                P.the.C=0;
             if(((A>>7) != (Operand.the.Byte>>7)) &&
                ((A>>7) != (char(Result)>>7)))
                P.the.V=1;
             else
                P.the.V=0;
             A=char(Result);
             if(A)
                P.the.Z=0;
             else
                P.the.Z=1;
             P.the.N=A>>7;
          }
          PC+=2;
          Idle=4;
          break;

       //  
       default:
          Bye("CPU","Unrecognized command");
    }
 }

 void TCPU::PushByte(TByte byteIn)
 {
    if(!S)
       Bye("CPU","Stack overflow");
    MEM->Cell[0x0100+(S--)]=byteIn;
 }

 void TCPU::PushWord(TWord wordIn)
 {
    if(!S || !(S-1))
       Bye("CPU","Stack overflow");
    MEM->Cell[0x0100+(S--)]=char(wordIn);
    MEM->Cell[0x0100+(S--)]=char(wordIn>>8);
 }

 TByte TCPU::PopByte()
 {
    if(S==0xFF)
       Bye("CPU","Stack underflow");
    return MEM->Cell[0x0100+(++S)];
 }

 TWord TCPU::PopWord()
 {
    if(S==0xFF || (S+1)==0xFF)
       Bye("CPU","Stack underflow");
    TByte byteLo,
          byteHi;
    TWord wordResult;
    byteHi=MEM->Cell[0x0100+(++S)];
    byteLo=MEM->Cell[0x0100+(++S)];
    wordResult=byteHi;
    wordResult<<=8;
    wordResult+=byteLo;
    return wordResult;
 }

 #endif