
 #ifndef _CPU_H
 #define _CPU_H

 /* ,    Motorola6502 */

 class TCPU
 {
    public:
       TCPU();
       ~TCPU();
       void Init(TMEM *MEMIn, TVS *VSIn, TKB *KBIn);
       void Tick();
       //  
       TWord PC; //  
       TByte S;  //  
       TByte X;  //  
       TByte Y;  //  
       TByte A;  // 
       //  
       union
       {
          TByte All;
          struct
          {
             TByte N:1; //   
             TByte V:1; //  
             TByte reserved:1;
             TByte B:1; //
             TByte D:1; //   
             TByte I:1; //
             TByte Z:1; //   
             TByte C:1; //  
          } the;   
       } P;
    protected:
       TMEM *MEM;
       TVS *VS;
       TKB *KB;
       //   
       TByte Command;

       // ,   
       //  ,   
       //      ! 
       union
       {
          struct
          {
             union
             {
                TByte LoByte;
                TByte Byte;
             };
             union
             {
                TByte HiByte;
                TByte NotUse;
             };
          } the;
          TWord Word;
       } Operand;
       
       //   ,  
       //  
       TByte Idle;
       /*    */
       void PushByte(TByte byteIn);
       void PushWord(TWord wordIn);
       TByte PopByte();
       TWord PopWord();
 };

 #endif