
 #ifndef _GRAPHLIB_H
 #define _GRAPHLIB_H

 #define GBlack        0x0000
 #define GBlue         0x0001
 #define GGreen        0x0002
 #define GCyan         0x0003
 #define GRed          0x0004
 #define GMagenta      0x0005
 #define GBrown        0x0006
 #define GLightGray    0x0007
 #define GDarkGray     0x0008
 #define GLightBlue    0x0009
 #define GLightGreen   0x000A
 #define GLightCyan    0x000B
 #define GOrange       0x000C
 #define GLightMagenta 0x000D
 #define GYellow       0x000E
 #define GWhite        0x000F

 void Set0x03Mode()
 {
    asm {
       //    BIOS
       mov ax,0x0003;
       int 0x10;
    }
 }

 void Set0x12Mode()
 {
    asm {
       //    BIOS
       mov ax,0x0012;
       int 0x10;
    }
 }

 void PutPixel(unsigned int x, unsigned int y, unsigned int color)
 {
    asm {
       push    es
       pusha
       mov     ax,0xA000
       mov     es,ax

       xor     bx,bx
       mov     ax,y
       shl     ax,2
       add     ax,y
       shl     ax,4
       mov     cx,x
       push    cx
       shr     cx,3
       add     ax,cx
       mov     di,ax
       pop     cx
       and     cx,0x07
       mov     bx,0x0080
       shr     bx,cl

       //     
       // 
       mov     dx,0x03CE
       mov     ax,0x0F01
       out     dx,ax

       mov     ax,color
       shl     ax,0x08
       out     dx,ax
       mov     al,0x08
       mov     ah,bl
       out     dx,ax
       mov     ah,byte ptr es:[di]
       mov     byte ptr es:[di],ah
       popa
       pop     es
    }
 }

 /*void Clear0x12Mode()
 {
    for(unsigned int y=0; y<480; y++)
       for(unsigned int x=0; x<640; x++)
          PutPixel(x, y, 0);
    return;
    asm {
       push    es
       push    di
       push    ax
       push    cx
       mov     ax,0xA000
       mov     es,ax
       mov     ax,0x0000
       mov     di,ax
       mov     cx,0xFFFF
       rep     stosw
       pop     cx
       pop     ax
       pop     di
       pop     es
    }
 } */

 #endif
