
 #ifndef _MEM_CPP
 #define _MEM_CPP

 TMEM::TMEM()
      :Cell(NULL)
 {
    Cell=new TByte [0xFFFF];
    if(!Cell)
       Bye("MEM","Cannot create dinamic Memory Array!");
 }

 TMEM::~TMEM()
 {
    delete [] Cell;
 }

 void TMEM::Init(TVS *VSIn, TKB *KBIn)
 {
    VS=VSIn;
    KB=KBIn;
    for(TWord index=0; index<0xFFFF; index++)
       Cell[index]=0x00;
    IOZoneBegin=0xC000;
    IOZoneEnd=0xCFFF;
    ROMZoneBegin=0xD000;
    ROMZoneEnd=0xFFFF;
 }

 TByte TMEM::Read(TWord address)
 {
    /*       / */
    if(address>=IOZoneBegin && address <=IOZoneEnd)
    {
        /*  */
        //   
        if(address>=0xC000 && address<=0xC00F)
        {
           KB->GetKey();
           goto ReadReturn;
        }
        //  
        if(address>=0xC010 && address<=0xC01F)
        {
           KB->Strobe();
           goto ReadReturn;
        }
        //   (/LAT)
        if(address==0xC063)
        {
            KB->GetRegister();
            goto ReadReturn;
        }
    }
 ReadReturn:
    return Cell[address];
 }

 void TMEM::Write(TWord address, TByte byteIn)
 {
    /*     
         */

    //  
    if(address>=0xC010 && address<=0xC01F)
    {
       KB->Strobe();
       return;
    }

    //    /
    if(address>=IOZoneBegin && address<=IOZoneEnd)
    {
       //  
       if(address>=0xC058 && address<=0xC05B)
       {
          VS->SetPalette(address);
          return;
       }
       //  
       if(address>=0xC700 && address<=0xC7FF)
       {
          VS->SetMode(address);
          return;
       }
    }

    //   
    if(address>=VS->VideoZoneBegin && address<=VS->VideoZoneEnd)
    {
       Cell[address]=byteIn;
       VS->ModifyScreen(address);
       return;
    }

    //      
    Cell[address]=byteIn;
 }

 #endif _MEM_CPP
