
 #ifndef _VS_CPP
 #define _VS_CPP

 TVS::TVS()
     :Font(NULL)
 {
    Font=new TWord[256*15];
    if(!Font)
       Bye("VS","Cannot dinamic allocate memory for Font");
    FILE *FontFile;
    FontFile=fopen("Agat.fnt","rb");
    if(!FontFile)
       Bye("VS","Cannot load font file");
    fread(Font, 256*15*2, 1, FontFile);
    fclose(FontFile);
 }

 TVS::~TVS()
 {
    if(Font)
       delete [] Font;
 }

 void TVS::Init(TMEM *MEMIn)
 {
    MEM=MEMIn;
    Set0x12Mode();
    Mode=TXT32;
    VideoZoneBegin=0x1000;
    VideoZoneEnd=0x17FF;
    //   
    BeforePaletteAddress=0;
    SetPalette(0xC058);
    SetPalette(0xC05A);
 }

 void TVS::SetMode(TWord address)
 {
    switch(address)
    {
       /*   TXT32 */
       case 0xC702:
          Mode=TXT32;
          VideoZoneBegin=0x0000;
          VideoZoneEnd=0x07FF;
          break;
       case 0xC706:
          Mode=TXT32;
          VideoZoneBegin=0x0800;
          VideoZoneEnd=0x0FFF;
          break;
       //  #3
       case 0xC70A:
          Mode=TXT32;
          VideoZoneBegin=0x1000;
          VideoZoneEnd=0x17FF;
          break;
       case 0xC70E:
          Mode=TXT32;
          VideoZoneBegin=0x1800;
          VideoZoneEnd=0x1FFF;
          break;
       case 0xC712:
          Mode=TXT32;
          VideoZoneBegin=0x2000;
          VideoZoneEnd=0x27FF;
          break;
       case 0xC716:
          Mode=TXT32;
          VideoZoneBegin=0x2800;
          VideoZoneEnd=0x2FFF;
          break;
       case 0xC71A:
          Mode=TXT32;
          VideoZoneBegin=0x3000;
          VideoZoneEnd=0x37FF;
          break;
       case 0xC71E:
          Mode=TXT32;
          VideoZoneBegin=0x3800;
          VideoZoneEnd=0x3FFF;
          break;
       case 0xC722:
          Mode=TXT32;
          VideoZoneBegin=0x4000;
          VideoZoneEnd=0x47FF;
          break;
       case 0xC726:
          Mode=TXT32;
          VideoZoneBegin=0x4800;
          VideoZoneEnd=0x4FFF;
          break;
       case 0xC72A:
          Mode=TXT32;
          VideoZoneBegin=0x5000;
          VideoZoneEnd=0x57FF;
          break;
       case 0xC72E:
          Mode=TXT32;
          VideoZoneBegin=0x5800;
          VideoZoneEnd=0x5FFF;
          break;
       case 0xC732:
          Mode=TXT32;
          VideoZoneBegin=0x6000;
          VideoZoneEnd=0x67FF;
          break;
       case 0xC736:
          Mode=TXT32;
          VideoZoneBegin=0x6800;
          VideoZoneEnd=0x6FFF;
          break;
       case 0xC73A:
          Mode=TXT32;
          VideoZoneBegin=0x7000;
          VideoZoneEnd=0x77FF;
          break;
       case 0xC73E:
          Mode=TXT32;
          VideoZoneBegin=0x7800;
          VideoZoneEnd=0x7FFF;
          break;
       case 0xC742:
          Mode=TXT32;
          VideoZoneBegin=0x8000;
          VideoZoneEnd=0x87FF;
          break;
       case 0xC746:
          Mode=TXT32;
          VideoZoneBegin=0x8800;
          VideoZoneEnd=0x8FFF;
          break;
       case 0xC74A:
          Mode=TXT32;
          VideoZoneBegin=0x9000;
          VideoZoneEnd=0x97FF;
          break;
       case 0xC74E:
          Mode=TXT32;
          VideoZoneBegin=0x9800;
          VideoZoneEnd=0x9FFF;
          break;
       case 0xC752:
          Mode=TXT32;
          VideoZoneBegin=0xA000;
          VideoZoneEnd=0xA7FF;
          break;
       case 0xC756:
          Mode=TXT32;
          VideoZoneBegin=0xA800;
          VideoZoneEnd=0xAFFF;
          break;
       case 0xC75A:
          Mode=TXT32;
          VideoZoneBegin=0xB000;
          VideoZoneEnd=0xB7FF;
          break;
       case 0xC75E:
          Mode=TXT32;
          VideoZoneBegin=0xB800;
          VideoZoneEnd=0xBFFF;
          break;
       case 0xC762:
          Mode=TXT32;
          VideoZoneBegin=0xC000;
          VideoZoneEnd=0xC7FF;
          break;
       case 0xC766:
          Mode=TXT32;
          VideoZoneBegin=0xC800;
          VideoZoneEnd=0xCFFF;
          break;
       case 0xC76A:
          Mode=TXT32;
          VideoZoneBegin=0xD000;
          VideoZoneEnd=0xD7FF;
          break;
       case 0xC76E:
          Mode=TXT32;
          VideoZoneBegin=0xD800;
          VideoZoneEnd=0xDFFF;
          break;
       case 0xC772:
          Mode=TXT32;
          VideoZoneBegin=0xE000;
          VideoZoneEnd=0xE7FF;
          break;
       case 0xC776:
          Mode=TXT32;
          VideoZoneBegin=0xE800;
          VideoZoneEnd=0xEFFF;
          break;
       case 0xC77A:
          Mode=TXT32;
          VideoZoneBegin=0xF000;
          VideoZoneEnd=0xF7FF;
          break;
       case 0xC77E:
          Mode=TXT32;
          VideoZoneBegin=0xF800;
          VideoZoneEnd=0xFFFF;
          break;

       /*   TXT64 */
       case 0xC782:
          Mode=TXT64;
          VideoZoneBegin=0x0000;
          VideoZoneEnd=0x07FF;
          break;
       case 0xC786:
          Mode=TXT64;
          VideoZoneBegin=0x0800;
          VideoZoneEnd=0x0FFF;
          break;
       //  #3
       case 0xC78A:
          Mode=TXT64;
          VideoZoneBegin=0x1000;
          VideoZoneEnd=0x17FF;
          break;
       case 0xC78E:
          Mode=TXT64;
          VideoZoneBegin=0x1800;
          VideoZoneEnd=0x1FFF;
          break;
       case 0xC792:
          Mode=TXT64;
          VideoZoneBegin=0x2000;
          VideoZoneEnd=0x27FF;
          break;
       case 0xC796:
          Mode=TXT64;
          VideoZoneBegin=0x2800;
          VideoZoneEnd=0x2FFF;
          break;
       case 0xC79A:
          Mode=TXT64;
          VideoZoneBegin=0x3000;
          VideoZoneEnd=0x37FF;
          break;
       case 0xC79E:
          Mode=TXT64;
          VideoZoneBegin=0x3800;
          VideoZoneEnd=0x3FFF;
          break;
       case 0xC7A2:
          Mode=TXT64;
          VideoZoneBegin=0x4000;
          VideoZoneEnd=0x47FF;
          break;
       case 0xC7A6:
          Mode=TXT64;
          VideoZoneBegin=0x4800;
          VideoZoneEnd=0x4FFF;
          break;
       case 0xC7AA:
          Mode=TXT64;
          VideoZoneBegin=0x5000;
          VideoZoneEnd=0x57FF;
          break;
       case 0xC7AE:
          Mode=TXT64;
          VideoZoneBegin=0x5800;
          VideoZoneEnd=0x5FFF;
          break;
       case 0xC7B2:
          Mode=TXT64;
          VideoZoneBegin=0x6000;
          VideoZoneEnd=0x67FF;
          break;
       case 0xC7B6:
          Mode=TXT64;
          VideoZoneBegin=0x6800;
          VideoZoneEnd=0x6FFF;
          break;
       case 0xC7BA:
          Mode=TXT64;
          VideoZoneBegin=0x7000;
          VideoZoneEnd=0x77FF;
          break;
       case 0xC7BE:
          Mode=TXT64;
          VideoZoneBegin=0x7800;
          VideoZoneEnd=0x7FFF;
          break;
       case 0xC7C2:
          Mode=TXT64;
          VideoZoneBegin=0x8000;
          VideoZoneEnd=0x87FF;
          break;
       case 0xC7C6:
          Mode=TXT64;
          VideoZoneBegin=0x8800;
          VideoZoneEnd=0x8FFF;
          break;
       case 0xC7CA:
          Mode=TXT64;
          VideoZoneBegin=0x9000;
          VideoZoneEnd=0x97FF;
          break;
       case 0xC7CE:
          Mode=TXT64;
          VideoZoneBegin=0x9800;
          VideoZoneEnd=0x9FFF;
          break;
       case 0xC7D2:
          Mode=TXT64;
          VideoZoneBegin=0xA000;
          VideoZoneEnd=0xA7FF;
          break;
       case 0xC7D6:
          Mode=TXT64;
          VideoZoneBegin=0xA800;
          VideoZoneEnd=0xAFFF;
          break;
       case 0xC7DA:
          Mode=TXT64;
          VideoZoneBegin=0xB000;
          VideoZoneEnd=0xB7FF;
          break;
       case 0xC7DE:
          Mode=TXT64;
          VideoZoneBegin=0xB800;
          VideoZoneEnd=0xBFFF;
          break;
       case 0xC7E2:
          Mode=TXT64;
          VideoZoneBegin=0xC000;
          VideoZoneEnd=0xC7FF;
          break;
       case 0xC7E6:
          Mode=TXT64;
          VideoZoneBegin=0xC800;
          VideoZoneEnd=0xCFFF;
          break;
       case 0xC7EA:
          Mode=TXT64;
          VideoZoneBegin=0xD000;
          VideoZoneEnd=0xD7FF;
          break;
       case 0xC7EE:
          Mode=TXT64;
          VideoZoneBegin=0xD800;
          VideoZoneEnd=0xDFFF;
          break;
       case 0xC7F2:
          Mode=TXT64;
          VideoZoneBegin=0xE000;
          VideoZoneEnd=0xE7FF;
          break;
       case 0xC7F6:
          Mode=TXT64;
          VideoZoneBegin=0xE800;
          VideoZoneEnd=0xEFFF;
          break;
       case 0xC7FA:
          Mode=TXT64;
          VideoZoneBegin=0xF000;
          VideoZoneEnd=0xF7FF;
          break;
       case 0xC7FE:
          Mode=TXT64;
          VideoZoneBegin=0xF800;
          VideoZoneEnd=0xFFFF;
          break;

       /*   GR256Lo */
       case 0xC703:
          Mode=GR256Lo;
          VideoZoneBegin=0x0000;
          VideoZoneEnd=0x1FFF;
          break;
       case 0xC713:
          Mode=GR256Lo;
          VideoZoneBegin=0x2000;
          VideoZoneEnd=0x3FFF;
          break;
       case 0xC723:
          Mode=GR256Lo;
          VideoZoneBegin=0x4000;
          VideoZoneEnd=0x5FFF;
          break;
       case 0xC733:
          Mode=GR256Lo;
          VideoZoneBegin=0x6000;
          VideoZoneEnd=0x7FFF;
          break;
       case 0xC743:
          Mode=GR256Lo;
          VideoZoneBegin=0x8000;
          VideoZoneEnd=0x9FFF;
          break;
       case 0xC753:
          Mode=GR256Lo;
          VideoZoneBegin=0xA000;
          VideoZoneEnd=0xBFFF;
          break;
       case 0xC763:
          Mode=GR256Lo;
          VideoZoneBegin=0xC000;
          VideoZoneEnd=0xDFFF;
          break;
       case 0xC773:
          Mode=GR256Lo;
          VideoZoneBegin=0xE000;
          VideoZoneEnd=0xFFFF;
          break;

       /*   GR256Hi */
       case 0xC700:
          Mode=GR256Hi;
          VideoZoneBegin=0x0000;
          VideoZoneEnd=0x3FFF;
          break;
       case 0xC720:
          Mode=GR256Hi;
          VideoZoneBegin=0x4000;
          VideoZoneEnd=0x7FFF;
          break;
       case 0xC740:
          Mode=GR256Hi;
          VideoZoneBegin=0x8000;
          VideoZoneEnd=0xBFFF;
          break;
       case 0xC760:
          Mode=GR256Hi;
          VideoZoneBegin=0xC000;
          VideoZoneEnd=0xFFFF;
          break;

       /*   GR512 */
       case 0xC783:
          Mode=GR512;
          VideoZoneBegin=0x0000;
          VideoZoneEnd=0x3FFF;
          break;
       case 0xC7A3:
          Mode=GR512;
          VideoZoneBegin=0x4000;
          VideoZoneEnd=0x7FFF;
          break;
       case 0xC7C3:
          Mode=GR512;
          VideoZoneBegin=0x8000;
          VideoZoneEnd=0xBFFF;
          break;
       case 0xC7E3:
          Mode=GR512;
          VideoZoneBegin=0xC000;
          VideoZoneEnd=0xFFFF;
          break;
    }
    //   
    TWord Temp=BeforePaletteAddress;
    switch(PaletteNumber)
    {
       case 1:
          SetPalette(0xC058);
          SetPalette(0xC05A);
          break;
       case 2:
          SetPalette(0xC059);
          SetPalette(0xC05A);
          break;
       case 3:
          SetPalette(0xC058);
          SetPalette(0xC05B);
          break;
       case 4:
          SetPalette(0xC058);
          SetPalette(0xC05B);
          break;
    }
    BeforePaletteAddress=Temp;
 }

 void TVS::ModifyScreen(TWord address)
 {
    switch(Mode)
    {
       case TXT32:
       {
          if(address&0x0001)
             address--;
          TWord VideoZoneOffset=address-VideoZoneBegin;
          TWord y=VideoZoneOffset/64;
          TWord x=(VideoZoneOffset-y*64)/2;
          PutSymbol32(x, y, MEM->Cell[address], MEM->Cell[address+1]);
          break;

       }
       case TXT64:
       {
          TWord VideoZoneOffset=address-VideoZoneBegin;
          TWord y=VideoZoneOffset/64;
          TWord x=VideoZoneOffset-y*64;
          PutSymbol64(x, y, MEM->Cell[address]);
          break;
       }
       case GR256Lo:
       {
          TWord VideoZoneOffset, xAgat, yAgat, xPC, yPC;
          VideoZoneOffset=address-VideoZoneBegin;
          yAgat=(VideoZoneOffset)>>5;
          xAgat=(VideoZoneOffset-(yAgat<<5))<<3;
          /*
                256*256  
                 640*480.
                -    64 ,
              X ,  Y - :
             7  ,     ..
          */
          yPC=(yAgat<<1)-((yAgat)/8);
          xPC=(xAgat<<1)+64;
          int bit;
          //  
          //if(yAgat%8)
          //{
          //   yPC++;
          //   for(int i=7; i>=0; i--)
          //   {
          //      bit=(MEM->Cell[address]>>i)&0x01;
          //      PutPixel(xPC++, yPC, Color[bit]);
          //      PutPixel(xPC++, yPC, Color[bit]);
          //   }
          //}
          //  
          //else
          //{
             for(int i=7; i>=0; i--)
             {
                bit=(MEM->Cell[address]>>i)&0x01;
                PutPixel(xPC++, yPC, Color[bit]);
                PutPixel(xPC++, yPC, Color[bit]);
             }
             yPC++;
             xPC=(xAgat<<1)+64;
             for(int i=7; i>=0; i--)
             {
                bit=(MEM->Cell[address]>>i)&0x01;
                PutPixel(xPC++, yPC, Color[bit]);
                PutPixel(xPC++, yPC, Color[bit]);
             }
          //}
          break;
       }
       case GR256Hi:
       {
          TWord VideoZoneOffset, xAgat, yAgat, xPC, yPC;
          VideoZoneOffset=address-VideoZoneBegin;
          yAgat=(VideoZoneOffset)>>6;
          xAgat=(VideoZoneOffset-(yAgat<<6))<<2;
          /*
                256*256  
                 640*480.
                -    64 ,
              X ,  Y - :
             7  ,     ..
          */
          yPC=(yAgat<<1)-((yAgat)/8);
          xPC=(xAgat<<1)+64;
          int bit;
          //  
          //if(yAgat%8)
          //{
          //   yPC++;
          //   for(int i=7; i>=0; i--)
          //   {
          //      bit=(MEM->Cell[address]>>i)&0x01;
          //      PutPixel(xPC++, yPC, Color[bit]);
          //      PutPixel(xPC++, yPC, Color[bit]);
          //   }
          //}
          //  
          //else
          //{
             for(int i=6; i>=0; i-=2)
             {
                bit=(MEM->Cell[address]>>i)&0x03;
                PutPixel(xPC++, yPC, Color[bit]);
                PutPixel(xPC++, yPC, Color[bit]);
             }
             yPC++;
             xPC=(xAgat<<1)+64;
             for(int i=6; i>=0; i-=2)
             {
                bit=(MEM->Cell[address]>>i)&0x03;
                PutPixel(xPC++, yPC, Color[bit]);
                PutPixel(xPC++, yPC, Color[bit]);
             }
          //}
          break;
       }
       case GR512:
       {
          TWord VideoZoneOffset, xAgat, yAgat, xPC, yPC;
          VideoZoneOffset=address-VideoZoneBegin;
          yAgat=(VideoZoneOffset)>>6;
          xAgat=(VideoZoneOffset-(yAgat<<6))<<3;
          /*
                256*256  
                 640*480.
                -    64 ,
              X  ,  Y - :
             7  ,     ..
          */
          yPC=(yAgat<<1)-((yAgat)/8);
          xPC=xAgat+64;
          int bit;
          //  
          //if(yAgat%8)
          //{
          //   yPC++;
          //   for(int i=7; i>=0; i--)
          //   {
          //      bit=(MEM->Cell[address]>>i)&0x01;
          //      PutPixel(xPC++, yPC, Color[bit]);
          //      PutPixel(xPC++, yPC, Color[bit]);
          //   }
          //}
          //  
          //else
          //{
             for(int i=7; i>=0; i--)
             {
                bit=(MEM->Cell[address]>>i)&0x01;
                PutPixel(xPC++, yPC, Color[bit]);
             }
             yPC++;
             xPC=xAgat+64;
             for(int i=7; i>=0; i--)
             {
                bit=(MEM->Cell[address]>>i)&0x01;
                PutPixel(xPC++, yPC, Color[bit]);
             }
          //}

          break;
       }
    }
 }

 void TVS::ShowScreen()
 {
    switch(Mode)
    {
       case TXT32:
       {
          TWord index=VideoZoneBegin;
          for(TWord y=0; y<32; y++)
             for(TWord x=0; x<32; x++)
             {
                PutSymbol32(x, y, MEM->Cell[index], MEM->Cell[index+1]);
                index+=2;
             }
          break;
       }
       case TXT64:
       {
          TWord index=VideoZoneBegin;
          for(TWord y=0; y<32; y++)
             for(TWord x=0; x<64; x++)
                PutSymbol64(x, y, MEM->Cell[index++]);
          break;
       }
       case GR256Lo:
       {
          TWord VideoZoneOffset, xAgat, yAgat, xPC, yPC;
          for(TWord address=VideoZoneBegin; address<=VideoZoneEnd; address++)
          {
             VideoZoneOffset=address-VideoZoneBegin;
             yAgat=(VideoZoneOffset)>>5;
             xAgat=(VideoZoneOffset-(yAgat<<5))<<3;
             /*
                   256*256  
                    640*480.
                   -    64 ,
                 X ,  Y - :
                7  ,     ..
             */
             yPC=(yAgat<<1)-((yAgat)/8);
             xPC=(xAgat<<1)+64;
             int bit;
             //  
             //if(yAgat%8)
             //{
             //   yPC++;
             //   for(int i=7; i>=0; i--)
             //   {
             //      bit=(MEM->Cell[address]>>i)&0x01;
             //      PutPixel(xPC++, yPC, Color[bit]);
             //      PutPixel(xPC++, yPC, Color[bit]);
             //   }
             //}
             //  
             //else
             //{
                for(int i=7; i>=0; i--)
                {
                   bit=(MEM->Cell[address]>>i)&0x01;
                   PutPixel(xPC++, yPC, Color[bit]);
                   PutPixel(xPC++, yPC, Color[bit]);
                }
                yPC++;
                xPC=(xAgat<<1)+64;
                for(int i=7; i>=0; i--)
                {
                   bit=(MEM->Cell[address]>>i)&0x01;
                   PutPixel(xPC++, yPC, Color[bit]);
                   PutPixel(xPC++, yPC, Color[bit]);
                }
             //}
          }
          break;
       }
       case GR256Hi:
       {
          TWord VideoZoneOffset, xAgat, yAgat, xPC, yPC;
          for(TWord address=VideoZoneBegin; address<=VideoZoneEnd; address++)
          {
             VideoZoneOffset=address-VideoZoneBegin;
             yAgat=(VideoZoneOffset)>>6;
             xAgat=(VideoZoneOffset-(yAgat<<6))<<2;
             if(yAgat<128)
                yAgat<<=1;
             else
                yAgat=(yAgat-128)*2+1;
             for(TWord i=0; i<4; i++)
                PutPixel(192+xAgat++, 112+yAgat, Color[(((MEM->Cell[address])<<(2*i))>>6)]);
             break;
          }
       }
       case GR512:
       {
          TWord VideoZoneOffset, xAgat, yAgat, xPC, yPC;
          for(TWord address=VideoZoneBegin; address<=VideoZoneEnd; address++)
          {
             VideoZoneOffset=address-VideoZoneBegin;
             yAgat=(VideoZoneOffset)>>6;
             xAgat=(VideoZoneOffset-(yAgat<<6))<<3;
             if(yAgat<128)
                yAgat<<=1;
             else
                yAgat=(yAgat-128)*2+1;
             for(TWord i=0; i<8; i++)
                if((((MEM->Cell[address])<<i)>>7))
                   PutPixel(64+xAgat++, 112+yAgat, Color[1]);
                else
                   PutPixel(64+xAgat++, 112+yAgat, Color[0]);
             break;
          }
       }
    }
 }

 void TVS::PutSymbol32(TWord x, TWord y, TByte symbol, TByte attribute)
 {
    //   - 20*15 (   - 10*15, 
    //   x    )
    //     15   2 ,
    //    10   16
    TWord YScreen=y*15;
    for(TWord WordCounter=0; WordCounter<15; WordCounter++)
    {
       TWord TheWord=Font[symbol*15+WordCounter];
       TWord XScreen=x*20;
       for(int BitCounter=9; BitCounter>=0; BitCounter--)
       {
          TWord Pix=(TheWord<<(6+(9-BitCounter)))>>15;
          //   
          // (  ,    )
          switch((attribute>>5)&0x0001)
          {
             // 
             case 1:
                switch(Pix)
                {
                   case 1:
                      PutPixel(XScreen, YScreen, Color[attribute&0x07]);
                      PutPixel(XScreen+1, YScreen, Color[attribute&0x07]);
                      break;
                   case 0:
                      PutPixel(XScreen, YScreen, Color[0]);
                      PutPixel(XScreen+1, YScreen, Color[0]);
                      break;
                }
                break;
             // 
             case 0:
                switch(Pix)
                {
                   case 1:
                      PutPixel(XScreen, YScreen, Color[0]);
                      PutPixel(XScreen+1, YScreen, Color[0]);
                      break;
                   case 0:
                   PutPixel(XScreen, YScreen, Color[attribute&0x07]);
                      PutPixel(XScreen+1, YScreen, Color[attribute&0x07]);
                      break;
                }
                break;
          }
          XScreen=XScreen+2;
       }
       YScreen++;
    }
 }

 void TVS::PutSymbol64(TWord x, TWord y, TByte symbol)
 {
    TWord YScreen=y*15;
    for(TWord WordCounter=0; WordCounter<15; WordCounter++)
    {
       TWord TheWord=Font[symbol*15+WordCounter];
       TWord XScreen=x*10;
       for(int BitCounter=9; BitCounter>=0; BitCounter--)
       {
          TWord Pix=(TheWord<<(6+(9-BitCounter)))>>15;
          if(Pix)
             PutPixel(XScreen, YScreen, Color[1]);
          else
             PutPixel(XScreen, YScreen, Color[0]);
          XScreen++;
       }
       YScreen++;
    }
 }

 void TVS::SetPalette(TWord address)
 {
    //  
    if(address==0xC05A && BeforePaletteAddress==0xC058)
    {
       PaletteNumber=1;
       switch(Mode)
       {
          case TXT32:
          case GR128:
             Color[0]=GBlack;
             Color[1]=GRed;
             Color[2]=GGreen;
             Color[3]=GYellow;
             Color[4]=GBlue;
             Color[5]=GMagenta;
             Color[6]=GCyan;
             Color[7]=GWhite;
             break;
          case GR256Hi:
             Color[0]=GBlack;
             Color[1]=GRed;
             Color[2]=GGreen;
             Color[3]=GBlue;
             break;
          case GR256Lo:
          case GR512:
             Color[0]=GBlack;
             Color[1]=GWhite;
             break;
          case TXT64:
             Color[0]=GBlack;
             Color[1]=GWhite;
             break;
       }
       ShowScreen();
    }
    //  
    if(address==0xC05A && BeforePaletteAddress==0xC059)
    {
       PaletteNumber=2;
       switch(Mode)
       {
          case TXT32:
          case GR128:
             Color[0]=GBlack;
             Color[1]=GRed;
             Color[2]=GGreen;
             Color[3]=GYellow;
             Color[4]=GBlue;
             Color[5]=GMagenta;
             Color[6]=GCyan;
             Color[7]=GWhite;
             break;
          case GR256Hi:
             Color[0]=GWhite;
             Color[1]=GRed;
             Color[2]=GGreen;
             Color[3]=GBlue;
             break;
          case GR256Lo:
          case GR512:
             Color[0]=GWhite;
             Color[1]=GBlack;
             break;
          case TXT64:
             Color[0]=GBlue;
             Color[1]=GWhite;
             break;
       }
       ShowScreen();
    }
    //  
    if(address==0xC05B && BeforePaletteAddress==0xC058)
    {
       PaletteNumber=3;
       switch(Mode)
       {
          case TXT32:
          case GR128:
             Color[0]=GBlack;
             Color[1]=GRed;
             Color[2]=GGreen;
             Color[3]=GYellow;
             Color[4]=GBlue;
             Color[5]=GMagenta;
             Color[6]=GCyan;
             Color[7]=GWhite;
             break;
          case GR256Hi:
             Color[0]=GBlack;
             Color[1]=GBlack;
             Color[2]=GGreen;
             Color[3]=GBlue;
             break;
          case GR256Lo:
          case GR512:
             Color[0]=GBlack;
             Color[1]=GGreen;
             break;
          case TXT64:
             Color[0]=GBlack;
             Color[1]=GWhite;
             break;
       }
       ShowScreen();
    }
    //  
    if(address==0xC05B && BeforePaletteAddress==0xC059)
    {
       PaletteNumber=4;
       switch(Mode)
       {
          case TXT32:
          case GR128:
             Color[0]=GBlack;
             Color[1]=GRed;
             Color[2]=GGreen;
             Color[3]=GYellow;
             Color[4]=GBlue;
             Color[5]=GMagenta;
             Color[6]=GCyan;
             Color[7]=GWhite;
             break;
          case GR256Hi:
             Color[0]=GBlack;
             Color[1]=GRed;
             Color[2]=GBlack;
             Color[3]=GBlue;
             break;
          case GR256Lo:
          case GR512:
             Color[0]=GGreen;
             Color[1]=GBlack;
             break;
          case TXT64:
             Color[0]=GMagenta;
             Color[1]=GWhite;
             break;
       }
       ShowScreen();
    }
    BeforePaletteAddress=address;
 }

 #endif